; Purpose: Emacs lisp mode for starting trale under emacs. 
;
; Author: Detmar Meurers
;
; Version: $Id: trale-emacs-interface.el,v 1.6 2002/11/26 01:36:42 dm Exp $
;
; Historical note: We now add our stuff on top of the ordinary
; prolog.el mode that comes with sicstus. This improves on our
; original gtrale.el mode (which directly used comint) in that it
; allows use of the source level debugger and other facilities
; provided by the prolog.el mode of sicstus. Different from gtrale.el,
; this new code should also be compatible with both xemacs and gnu
; emacs.

; Load the prolog mode
(load "prolog")

(setq prolog-system 'sicstus)

; Define the start-trale function, which is called in the shell script
; "trale" that's used for starting trale

(defun start-trale (program-name options startup-filename)
; wait for emacs to get to its feet:
  (sit-for 1)
; set the variables from the arguments and start prolog
  (setq prolog-program-name program-name)
  (setq sicstus-program-switches (split-string options))
  (run-prolog nil)
; wait until we see a prolog prompt
;  (wait-until-prompt)
; make the prolog window take up the entire frame:
  (delete-other-windows) 
; load startup files
  (unless (equal startup-filename "")
    (let* ((startup-load-command (concat "compile('" 
					 startup-filename
					 "').\n")))
      (prolog-process-insert-string (get-process "prolog") startup-load-command)
      (process-send-string "prolog" startup-load-command)))
  )

;; taken from definition of prolog-ensure-process in prolog.el
(defun wait-until-prompt ()
  (goto-char (point-max))
  (while
      (save-excursion
	(not
	 (re-search-backward
	  (concat "\\(" prolog-prompt-regexp-i "\\)" "\\=")
	  nil t)))
    (sit-for 0.1)))

; Specifications for the source level debugger (from Gerald):

(setq prolog-use-sicstus-sd t)

(setq pltrace-port-arrow-assoc '( 
	("call" . ">>>") ("exit" . "+++") ("ndexit" . "?++")
	("redo" . "<<<") ("fail" . "---") ("exception" . "==>")
        ("null" . nil)))

(setq auto-mode-alist
      (cons '("\\.pl$" . prolog-mode) auto-mode-alist))
