% $Id: follow.pl,v 1.3 2002/08/08 15:18:38 dm Exp $

:- ensure_loaded(lr_compiler(generalize)).

%:- dynamic follow/2.

do_follow :-
	get_inputs(InputList),
	(    lex_rule(ID,Input,Output),
	     incorporate_frames(ID,Input,Output,GenFS),
	     get_followList(GenFS,InputList,List),
	     assert(follow(ID,List)),
	     write(follow(ID,List)), nl,
	     fail
	 ;   true
         ).

incorporate_frames(ID,Input,Output,OutputFS) :-
	get_genFrame(ID,GenFrame),
	feat_fs2featval(in,GenFrame,In),
	desc2fs(Input,InputFS),
	ud(In,InputFS),
	feat_fs2featval(out,GenFrame,Out),
	desc2fs(Output,OutputFS),
	ud(Out,OutputFS).

% changed frame(ID,Disjunct) to frame_desc_bin(ID,Disjunct)

get_genFrame(ID,GenFrame) :-
	findall(Disjunct,frame_desc_bin(ID,Disjunct),Disjuncts),
	make_it_one(Disjuncts,GenFrame).

make_it_one([],_) :- !.
make_it_one([Desc],GenFrame) :- !,
	desc2fs(Desc,GenFrame).
make_it_one([Desc|List],GenFrame) :- !,
	desc2fs(Desc,FS),
	make_it_one(List,FS,GenFrame).

% changed it to call desc2fs(Desc,FS1)
% and made FS1 & Iq1 the first 2 arguments of get_genFS

make_it_one([],FS,FS) :- !.
make_it_one([Desc|List],FS,GenFS) :-
   desc2fs(Desc,FS1),
   get_genFS(FS1,FS,ResultFS),
   make_it_one(List,ResultFS,GenFS).

get_inputs(InputList) :-
	findall(Id-Input,lex_rule(Id,Input,_),InputList).

get_followList(_,[],[]) :- !.
get_followList(OutputFS,[ID-InputDesc|Rest],[ID|List]) :-
	desc2fs(InputDesc,InputFS),
	test_unify(OutputFS,InputFS),
	get_followList(OutputFS,Rest,List).
get_followList(OutputFS,[_|Rest],List) :-
	get_followList(OutputFS,Rest,List).

% defined in step_one.pl
%%%test_unify(X,Y) :-
%%%	retractall(they_unify),
%%%        unify_aux(X,Y),
%%%	they_unify.

%%%unify_aux(X,Y) :-
%%%	ud(X,Y),
%%%	assert(they_unify),
%%%	fail.
%%%unify_aux(_,_,_).
