% $Id: generalize.pl,v 1.2 2002/08/08 15:17:56 dm Exp $

get_genFS(FS1,FS2,GenFS) :-
	fs2type_feats(FS1,Type1,_),
	fs2type_feats(FS2,Type2,_),
	generalize(Type1,Type2,GenType),
	approp_feats(GenType,List),
	desc2fs(GenType,GenFS),
	assign_vals(List,FS1,FS2,GenFS).


assign_vals([],_,_,_) :- !.
assign_vals([Feat|Rest],FS1,FS2,GenFS) :-
   feat_fs2featval(Feat,FS1,Val1),
   feat_fs2featval(Feat,FS2,Val2),
   feat_fs2featval(Feat,GenFS,SmFS),
   (  condition(Val1) 
   -> SmFS = Val1
   ;  get_genFS(Val1,Val2,ResultFS),
      ud(ResultFS,SmFS)
   ),
   assign_vals(Rest,FS1,FS2,GenFS).


% condition(+FS)
% checks to see if 

condition(FS) :-
	  FS = A-Val,
	  var(A),
	  atom(Val).

%%%generalize(Type1,Type2,GenType) :-
%%%    unify_type(Type1,Type2,Type1),
%%%    !,
%%%    GenType = Type2.
%%%generalize(Type1,Type2,GenType) :-
%%%    unify_type(Type1,Type2,Type2),
%%%    !,
%%%    GenType = Type1.
%%%generalize(Type1,Type2,GenType) :-
%%%    imm_sub_type(SuperType,Type1),
%%%    generalize(SuperType,Type2,GenType).

generalize(Type1,Type2,GenType) :-
    unify_type(Type1,Type2,Type1),
    !,
    GenType = Type2.
generalize(Type1,Type2,GenType) :-
    unify_type(Type1,Type2,Type2),
    !,
    GenType = Type1.
generalize(Type1,Type2,GenType) :-
    imm_sub_type(SuperType,Type1),
    generalize(SuperType,Type2,GenType).
