% $Id: identity.pl,v 1.2 2002/08/08 15:17:37 dm Exp $

% identity(+ID,+FS)
% succeeds if the FS is already in the table somewhere

identity(ID,FS) :-
    table(ID,_,TableFS),
% add a cut?
    identical(FS,TableFS).

% identical(+FS1,+FS2)
% sees if these 2 FSs are exactly identical (variables notwithstanding)

% if one is a variable, the other must be, too, ...
identical(FS,TableFS) :-
    var(FS),
    !,
    var(TableFS).
% ... so if we get to this point & var(TableFS) succeeds, var(FS) will fail
identical(FS,TableFS) :-
    var(TableFS),
    !,
    var(FS).
% similarly with atomic status
identical(FS,TableFS) :-
    atom(FS),
    !,
    FS = TableFS.
identical(FS,TableFS) :-
    atom(TableFS),
    !,
    FS = TableFS.
% What's left are predicates:  arity must match & arguments must match
identical(FS,TableFS) :-
    functor(FS,Functor,Arity),
    functor(TableFS,TableFunctor,Arity),
    identical(Functor,TableFunctor),
    identical_args(Arity,FS,TableFS).

% identical_args(+Arity,+FS1,+FS2)
% checks every argument, by counting down, of FS1 and FS2 to make sure
% they are identical

identical_args(0,_FS,_TableFS).
identical_args(Arity,FS,TableFS) :-
    arg(Arity,FS,FSarg),
    arg(Arity,TableFS,TableFSarg),
    identical(FSarg,TableFSarg),
    NewArity is Arity - 1,
    identical_args(NewArity,FS,TableFS).

% -------------------    
