% $Id: subsume.pl,v 1.2 2002/08/08 15:12:13 dm Exp $

% subsumeFS(+FS1f,FS2)
% gets the types of FS1 and FS2 and sees if FS1's type is more general,
% then checks if the values for the appropriate features of FS1 subsume
% those for FS2

subsumeFS(FS1,FS2) :-
    fs2type_feats(FS1,Type1,_),
    fs2type_feats(FS2,Type2,_),
    unify_type(Type1,Type2,Type2),
    approp_feats(Type1,List),
    assign_somevals(List,FS1,FS2).

% assign_somevals(+FeatList,+FS1,+FS2)
% walks through the FeatList, seeing if the smaller feature structure for
% FS1 subsumes the smaller one for FS2

assign_somevals([],_,_).
assign_somevals([Feat|Rest],FS1,FS2) :-
    feat_fs2featval(Feat,FS1,Val1),
    feat_fs2featval(Feat,FS2,Val2),
    subsumeFS(Val1,Val2),
    assign_somevals(Rest,FS1,FS2).
