% $Id: unfold.pl,v 1.3 2002/08/08 19:20:28 dm Exp $

:- dynamic new_q/4.
:- dynamic u/1.

% unfold/0
% has a very similar structure to step_four (in step_four.pl)
% but here we unfold the frame specifications into the definite clauses

unfold :-
    tell('out_5unfold.pl'),
    retractall(new_q(_,_,_,_)),
    nl,
    (   lex_stuff(LexID,_Lex_Entry,_Lex_FS),
	(   lex_arc(LexID,StIn,StOut,RuleID,_Cycle),
	    nl,

	    % we find the appropriate frame and the most general FS from
	    % our table for this particular state

	    frame(RuleID,FrameIn,FrameOut),
	    table(LexID,StIn,FS),

	    % get_in_and_aux will find the appropriate FSs for this clause
	    % NB:  if get_in_and_aux fails, this should be because we picked
	    % the wrong frame predicate.  at some point, since we already
	    % pruned the automaton, this should succeed

	    get_in_and_aux(FS,FrameIn,FrameOut,IN,AUX),

	    % ignore this comment:
	    % make_def_rels(LexID,RuleID,StIn,StOut,IN,AUX)
	    
	    % only state this once

	    (   new_q(LexID,StIn,_,_) ->
		true
	    ;   lr_assert(new_q(LexID,StIn,Same,Same))
	    ),

	    lr_assert((new_q(LexID,StIn,IN,OUT):-lex_rule(RuleID,IN,AUX),new_q(LexID,StOut,AUX,OUT))),

	    (    lex_arc(LexID,StOut,_,_,_) ->
		 true
	    ;    lr_assert(new_q(LexID,StOut,Var,Var))
	    ),
	    nl,
	    fail
	;   true
	),
	fail
    ;   true
    ),
    
    told.

% get_in_and_aux(+Lex_FS,+FrameIn,+FrameOut,-IN,-AUX)
% if Lex_FS and FrameIn are unifiable, then IN and AUX are set equal
% to the frames.  otherwise, this fails.

get_in_and_aux(Lex_FS,FrameIn,FrameOut,IN,AUX) :-
    (   unifiable(Lex_FS,FrameIn) ->
	IN = FrameIn,
	AUX = FrameOut
    ).

% unifiable(+FS1,+FS2)
% tests to see if 2 FSs are unifiable, but crucially does not unify them

unifiable(Lex_FS,In) :-

    % if the 2 FSs unify, we note this in the database (u(yes)) and fail
    % undoing the unification between Lex_FS and In

    (   retractall(u(_)),
	Lex_FS = In,
	assert(u(yes)),
	fail
    ;   u(yes)
    ).
