% portray_fs(Type,FS,KeyedFeats,VisIn,VisOut,TagsIn,TagsOut,Col,
%            HookDataIn,HookDataOut)

% portray_ineq(FS1,FS2,RestIn,RestOut,VisIn,VisOut,TagsIn,TagsOut,Col,
%              HookDataIn,HookDataOut)

% recursive calls: print_fs and print_fs_nohook, print_ineq and 
%  print_ineq_nohook

% default printer written as hook (w/o type or feat hiding or FS expansion)

portray_fs(Type,FS,KeyedFeats,VisIn,VisOut,TagsIn,TagsOut,Col,HDIn,HDOut) :-
  deref(FS,Ref,_),
	
% print Tag if shared
  ( get_assoc(Ref,TagsIn,Tag) -> write('['),write(Tag),write('] ')
  ; true),

% print structure if not yet visited
  ( get_assoc(Ref,VisIn,_) -> VisOut = VisIn, TagsOut = TagsIn,
                              HDOut = HDIn     % already printed

% variable - use Type to print
%  ; var(FS) -> ( approp(_,Type,_) -> write('mgsat('),write(Type),write(')')
%               ; write(Type)
%               ),
%               put_assoc(FS,VisIn,_,VisOut),
%               TagsOut = TagsIn, HDOut = HDIn

% otherwise print Type and recurse
  ; write(Type),
    put_assoc(Ref,VisIn,_,VisMid),
    print_feats(KeyedFeats,VisMid,VisOut,TagsIn,TagsOut,Col,HDIn,HDOut)
  ).

print_feats([],Vis,Vis,Tags,Tags,_Col,HD,HD).
print_feats([fval(F,Val,Restr)|Feats],VisIn,VisOut,TagsIn,TagsOut,Col,
            HDIn,HDOut) :-
  nl,tab(Col),
  write_feature(F,LengthF),  % capitalise, print and count characters
  NewCol is Col + LengthF + 1,
  print_fs(Restr,Val,VisIn,VisMid,TagsIn,TagsMid,NewCol,HDIn,HDMid),
  print_feats(Feats,VisMid,VisOut,TagsMid,TagsOut,Col,HDMid,HDOut).


portray_ineq(FS1,FS2,Rest,Rest,VisIn,VisOut,TagsIn,TagsOut,Col,HDIn,HDOut) :-
  tab(Col),
  print_fs(bot,FS1,VisIn,VisMid,TagsIn,TagsMid,Col,HDIn,HDMid),
  nl,write('  =\\=  '), NewCol is Col + 7,
  print_fs(bot,FS2,VisMid,VisOut,TagsMid,TagsOut,NewCol,HDMid,HDOut).
