%%% ==================================================================
%%% $Id: startup.pl,v 1.180 2003/11/22 02:41:09 dm Exp $
%%%
%%% Main startup file to load the TRALE system
%%%
%%% This file expects to be loaded in a shell in which certain
%%% system variables are set, in particular TRALE_HOME, which should
%%% point to the directory including the trale prolog files. The normal
%%% way of starting the system therefore is by executing the "trale" 
%%% shell script, which then loads this file.
%%%
%%% ==================================================================

% Define version of this release:

trale_milca_version('2.7.10').

% 2.7.10 changes/new features (Detmar)
%        socket_interface.pl: added handling of file sockets,
%          and made them the default for grisu running on localhost
%        trale, trale_extras.pl: fixed removal of user command file after use
%        lr_compiler/step_one.pl: now allows special list syntax
%        lr_compiler/main.pl: bugfixes, added lr_compiler_input/1 user spec
%          changed compile_lrs/2 to /1 using a standard out filename
%        chart_display.pl: bugfix (Stefan)
%        ale.pl: bugfix (Gerald)
% 2.7.9 bugfix in ale.pl (add_to_type_ad_ typo)
% 2.7.8 bugfix in ghooks.pl (Detmar): some dtrs elements weren't shown
%                                     as tree branches 
% 2.7.7 bugfixes/changes (Stefan, Detmar):
%       test_suite_handling.pl, chart_display/ale_redefinitions.pl
%       chart_display/chart_display.pl, tsdb/Makefile, tsdb/trale-itsdb.pl
%       new file: tsdb/tsdb-import, removed file chart_display/read.pl
% 2.7.6 bugfixes/changes by Gerald: ale.pl, trale.pl, trinterp.pl, interp.pl
% 2.7.5 bugfixes/changes:
%       -trale_extras.pl (Detmar):
%           - fixed typo in call of non-default tokenization
%           - added removal of user_cmd_file after startup
%       - trale-manual/manual.tex (Stefan):
%           - added some more information about incr tsdb
% 2.7.4 bugfixes/new features (Detmar): 
%       -graphviz.pl: - catch and properly output output special type a_ _
%                     - new graphviz_option(svg,grisu) switches to display
%                       signature directly in new grisu version 1.4.0
%       -pth.pl: - bugfix for show_subtypes/1 and related preds caused
%                  by change in def of immed_subtypes/2 in ale.pl;
%                  we now define and use get_immed_subtypes/2, which
%                  returns [] for a_ atoms and otherwise calls immed_subtypes/2
%       -trale_extras.pl: - redefined save_tsdb_state/0 to include call to
%                           itsdb:connect_tsdb at startup of state
%                         - changed read_line_of_words/2 to use new,
%                           user definable tokenization routine:
%                           tokenize_sentence_string(+String,-Tokenlist,-StartSymbolDesc)
%                           plus a simple default tokenization as fallback.
%                           string2wordlist/2 now only includes basic case
%      -trale-itsdb.pl: - redid tokenization of the string and 
%                         calling of the parser. Tokenization now allows 
%                         a grammar to specify the tokenization that
%                         should be used. Parser now called in failure-driven
%                         loop and fixed problem with the incorrect number of
%                         solutions that used to be reported to itsdb.
% 2.7.3 bugfixes in
%       - trale-itsdb.pl, ale_redefinitions.pl (Stefan)
%         fixed edge_limit check and exception catch 
%       - trale (Detmar)
%         name of USER_CMD_FILE now includes hostname and process id
%         to support multiple machines running trale sharing the same disk
%       - graphviz.pl (Detmar)
%         Changed graphviz_option_default to ps and ghostview.
% 2.7.2 changes/bugfixes in ale.pl, trale.pl, interp.pl, trinterp.pl (Gerald)
% 2.7.1 bugfix in ale.pl (Detmar)
% 2.7.0 changes/bugfixes in ale.pl, trale.pl (Gerald):
%       - New, matrix-based signature compiler!
%       - Bugfix in ale.pl
% 2.6.0 - changes/bugfixes in ale.pl, trale.pl, inter.pl, trinterp.pl
%         in particular major revisions of error and warning output 
%         as well as of the source level debugger (Gerald)
%         Note for programmars: lex/3 changed to lex/2 !
%       - ghooks.pl: bugfix, concerning display of a_ atoms (Detmar)
%       - trale_extras.pl: added user predicates rec_all/1 
%         and rec_all/2 (Detmar)
%       - chart_display.pl: generation from chart edges now works (Stefan)
%       - updated trale manual (Detmar)
% 2.5.5 changes/bugfixes (Stefan):
%       - chart_display.pl: improved output for detecting loops
%       - ale_redefinitions.pl: fixed edge limit
%       - trale_manual/manual.tex: chart display info updated
% 2.5.4 changes/bugfixes:
%       - debug_unify.pl: add_to errors are now quiet (Stefan)
%       - grammar_interface.pl: bugfix in cont_path_/1 (Detmar)
%       - chart_display/ale_redefinitions.pl: mem overflow now caught (Stefan)
%       - chart_display/chart_display.pl: new functionality+bugfixes (Stefan) 
%       - chart_display/print_mrs.pl: added specialized mrs output (Stefan)
%       - tsdb/trale-itsdb.pl: bugfixes
% 2.5.3 - added debug unifier & integrated in chart display (Stefan)
%       - changes/bugfixes in startup.pl (Detmar)
%       - changes/bugfixes in chart_display.pl; is always loaded now 
%         but must be switched on with chart_display/0 (Stefan, Detmar)
%       - add_to now quiet in diff.pl (Detmar)
%       - added cont_path/1, event_type/1, index_type/1 
%         grammar declarations to grammar_interface.pl (Stefan)
%       - changed pth.pl and graphviz.pl to also work with old-style
%         ale signatures, i.e. when sub and intro statements are provided
%         in the theory file instead of as separate signature (Detmar)
%       - added print_signature/1 and print_signature/0 to pth.pl to output
%         the signature of a grammar in signature input format (Detmar)
%       - eliminated chart_display/lib.pl (Stefan)
% 2.5.2 Added graphviz interface to display hierarchies (Detmar)
% 2.5.1 Additions/Reorganization (Detmar):
%       - test_suite_handling.pl: added number of edges to output,
%         changed ouput of time to minutes/seconds, and integrated 
%         all requested changes from chart_display/ale_redefinitions.pl
%       - trale: added -x option for chosing emacs instead of xemacs
%       - trale_patches.pl: redefined reverse_count/5 from ale.pl to add
%         add lookup of words so that it fails if unknown words are in string
%       - chart_display/ale_redefinitions: eliminated no longer needed
%         all_words_known/1,error/2, and the redefinition for rect/3 and
%         get_and_show_solution/3.
% 2.5.0 Integrated Stefan Mueller's prolog inteface to the TCL/TK
%       chart display of Patric Stiffel (c) 1997-1999
%       developed as part of the masterthesis at the DFKI, Saarbruecken.
% 2.4.1 Additions/Bugfixes (Detmar):
%       - trale/trale_extras.pl/startup.pl: simplified code and added
%         new options: "-c filename" compiles grammar after startup
%                      "-e prolog-command" executes command after startup
%                                          (and after -c if one is given)
%         modified option: names given for options -l and -c
%                          can include a relative or absolute path.
%                          This path becomes the working directory of trale.
%         eliminated option: -t (just use "-l tsdb")
%       - feature_ordering.pl: bugfix
% 2.4.0 Changes/Additions (Detmar)
%       - trale/trale_extras.pl: extended saving states to handle
%         user states, saved with "save_state(filename)" and loaded
%         by starting "trale -l filename" as well as support
%         for saving a tsdb state after compiling a grammar, with 
%         "save_tsdb_state" and starting it with "trale -t"
% 2.3.9 Bugfixes/Changes (Detmar):
%       - unfill.pl: in certain cases a_ atoms were unfilled even if 
%                    they had an informative argument
%       - trale: new variable EMACS_OPTIONS to improve generality
%       - ale.pl/test_suite_handling.pl Removed the retract wrappers 
%         around lookup of to_rebuild/1 in rec/4 and rec/5 so that one 
%         keeps access to the spanning edges, e.g. for the chart display.
% 2.3.8 Bugfixes (Detmar):
%       - ghooks.pl: empty/1 now works properly 
%       - startup.pl: setting of trale_home file search path fixed
%       - feature_ordering.pl: rewrote this from scratch
% 2.3.7 Bugfixes in ghooks.pl (Detmar):
%         - macro/1 now properly output, including structure sharings 
%         - don't allow unfilling of hd and tl of lists, because of
%           special notation used to display those
%         - feature names no longer output to grisu as capitalized
%           (capitalization is done in grisu, latex output uses \textsc)
% 2.3.6 Changes/Additions (Detmar):
%       - trale_extras.pl: new user command: lex_desc(word,desc).
%       - sockets.pl: new system command: start_client(+Hostname,+Port)
%       - test suite changed to use runtime of the process instead of walltime
%       - started reorganization of ghooks.pl
% 2.3.5 Bugfix (Detmar):
%       - startup.pl/trale.pl: changed use of file_search_path/2 to
%         make this work with changed setup in sicstus 3.10.0
% 2.3.4 Changes/Additions (Detmar):
%       - macro_utils.pl: renamed check_macros/0 to check_lmacros/0 
%         since only applies to logical variable macros.
%       - test_suite_handling.pl: added warnings and t(Nr, Words, NumSol)
%       - trale_extras.pl: rewrote tokenizer used by rec/0 and test suite 
%       - trale: added tests and error messages
% 2.3.3 - added user predicate check_macros/0 which checks consistency of 
%         logical variable macros and reports if they are disjunctive or
%         have residual goals attached to them. See macro_utils.pl (Detmar)
% 2.3.2 - bugfix in ale.pl (Gerald)
% 2.3.1 - change to diff.pl (Detmar)
%         The arguments of diff/2 (and diff/4) can now either be the number 
%         of a saved data structure (as before) or a description.
%       - bugfix in ghooks.pl: now respects unfilling for any node (Detmar)
% 2.3.0 - added first release of lexical rule compiler (Vanessa,Detmar)
% 2.2.5 - bugfixes to ale.pl (Gerald)
% 2.2.4 - bugfixes to ale.pl and trale.pl (Gerald)
% 2.2.3 - bugfix to feature_ordering.pl (Detmar)
%         It now catches & reports attempts to order unintroduced features. 
% 2.2.2 - bugfixes to trale.pl and ale.pl (Gerald)
%       - added user error feedback to pth.pl and trale.pl (Detmar)
%       - bugfix in feature_order.pl (Detmar)
%       - bugfix in pth.pl (Detmar)
% 2.2.1 - Made exchange of hostname and port between grisu and 
%         trale script safer.
%         IMPORTANT: THIS TRALE VERSION ONLY RUNS WITH GRISU
%         VERSION 1.2.7 OR NEWER
%       - The following user specifications are now properly abolished
%         at each new compilation with compile_gram:
%         signature/1, <<</1, <<</2, >>>/2, hidden_feat/1,
%         dtrs_feat/1, phon_feat/1, list_type/1, ne_list_type/1, 
%         hd_feat/1, tl_feat/1.
%       - test_suite_handling now uses high-level portray hooks
% 2.2.0: The grisu pretty printing now hooks into higher level hooks
%        provided by ale.pl, instead of the low-level pp_fs. Rewrote
%        basic grisu hook as standalone code instead of hook. Whichever
%        hooks aren't provided yet by grisu now properly default to basic 
%        textual pretty printer of trale. Changes to ghooks.pl, diff.pl,
%        and save_results.pl (Detmar)
%        - ale.pl: bugfix for nonterminating macro/1 calls in 
% 2.1.9: Detmar:
% - tree_extensions.pl
%   moved grammar intreface code to separate file grammar_interface.pl
% - ghooks.pl
%   - added hooks for _mgsat, _lex, and _cat  
%   - phon_feat and dtrs_feat extraction now uses user definable names
%     and eliminates pretty printing failures from non-list values
% 2.1.8: 
%     ale.pl (Gerald): - fixed handling of deprecated +++>/2 syntax
%                      - bugfix for identity check with a_ atoms
%     interp.pl (Gerald): - bugfix for goal debugging
%     trale_extras.pl (Detmar): 
%     - Added predicates rec/0 and rec_desc/1 which handle a variety 
%       of free form input strings for parsing, e.g. map capital to 
%       lower letters, removes punctuation and quotes, etc
%     - rewrote options handling of trale script with getopts
%       instead of the deprecated and "variant-rich" getopt command
%       to hopefull obtain setup that works on all unix/linux versions
% 2.1.5 Gerald: changed ale.pl and debugger/interp.pl
%     - error given when multiple result arguments are given in a fun/1
%       specification
%     - error given when nullary function looks like a type
%     - 23 new print hooks for displaying (TR)ALE output
%       These currently do not work with the debugger.
%     - inequations are now printed separately from residues by the default
%       pretty-printer, and in the format used in previous versions of ALE
%     - subsumption checking on edges is now working again
%     - some internal modifications to clean up the code a bit
%     Detmar: lib.pl and doc/trale-manual
%     - commented out trale code in lib.pl
%     - first draft of trale-manual incorporating the various sub-documents
%       except for the ale manual, which stays a separate document
% 2.1.4 Gerald: bugfix in lib.pl, functional descriptions in ALE, 
%       definite clause attachments are now possible in lexical entries.
%       Detmar: bugfix in macro_utils.pl
% 2.1.3 simplified save_results.pl & now suppresses add_to errors (Detmar)
% 2.1.2 bugfix+change by Detmar to ghooks.pl
%       - Added proper treatment for a_ atoms, which are now mapped to
%         grisu (A...) structures -  until now they were just mapped to 
%         the argument of a_ and there was a bug for (a_ Variable) cases.
% 2.1.1 changes and bugfixes by Detmar:
%       - ghooks.pl extended to be able to handle subtypes of ne_list
%       - bugfix to save_results.pl 
%       - trale script now specifies localhost for local graphical interface,
%         new option -r now allows connecting to grisu running remotely 
% 2.1.0 new functionality and bugfixes by Gerald:
%       concerns: ale.pl, trale.pl, interp.pl, trinterp.pl, new: lib.pl
%       1) fixes memory overflow problem
%       2) speeds up the interpreter slightly
%       3) adds a new run-time option to the interpreter, dlex/0 and nodlex/0.
%          This controls whether the debugger uses the compiled lexicon/LRs or
%          steps through them during execution.  The default is nodlex/0 - 
%          use the compiled code.  This REALLY speeds the interpreter up.
%       4) adds a new library file lib.pl for auxiliary predicates.  
%          Currently, it adds compile_rest/[0,1] and dcompile_rest/1, 
%          for compiling everything except the type signature.  
%       5) adds a new built-in to ALE's definite clause language, 
%          prolog/2.  The second argument is a Prolog hook, like prolog/1, 
%          and the first argument is bound to an association list of the 
%          narrowly quantified variables with scope over the hook.  
%          ALE will no longer make narrow variable substitutions in 
%          hooks automatically - you have to use prolog/2 and do it
%          yourself (if you don't know what this means, then probably it 
%          doesn't  affect you).
%       6) some other minor bug fixes.
% 2.0   new core trale version from Gerald:
%       - source level debugger (new files: interp.pl, trinterp.pl)
%       - bug fixes in trale.pl and ale.pl
% 1.5.6 changes by Detmar:
%       - rewrote tree_extensions.pl to use term_expansion/2
%       - trale.pl: macro/2 looks up := by functor and arity now
%         Note that this means it only be used as macro(+,-)!
%       - macro_utils.pl now uses its own is_macro/2 to find all macro names
% 1.5.5 fixes by Detmar related to macro_utils:
%       - in macro_utils.pl: now also works with logical variable macros
%       - in trale.pl: macro/2 needed to be callable with variables as args
%       - in macro_utils.pl: fixed bug in most_general_in_hierarchy/2
% 1.5.4 fix by Gerald for bug in trale.pl causing constraints not
%       to be compiled
% 1.5.3 changes by Gerald on ale.pl and trale.pl
%       - .alec_throw now with permission for writing by different users
%       - phantom residuals removed that came from other edges
%       - goal bug in constraint compiler
%       changes by Detmar: write descriptions instead of fs in save_results.pl
%       and renamed user predicates more consistently in that file -> cf. doc
% 1.5.2 two bug fixes by Gerald on ale.pl and trale.pl
%       - argument typing for logical macros is now optional, as intended
%       - functional descriptions fixed
% 1.5.1 feature ordering and feature hiding statements now always compiled
%       when compile_gram or compile_grammar is called.
%       and fixed a bug in show_approp/1 
% 1.5.0 Added feature hiding (in feature_ordering.pl)
%       Added extend_access.pl 
% 1.4.2 Supports additional syntax in grisu 1.1.5 (diff.pl and ghooks.pl)
% 1.4.1 Bugfixes for diff (and minor stuff in ghooks and save_results)
% 1.4.0 Added diff of feature structures (diff.pl) 
% 1.3.0 Added macro_utils.pl, user preds for showing macro hierarchies etc.
% 1.2.2 ghooks.pl uses cleaned up grisu 1.0.6 data exchange format
% 1.2.1 bugfix and cleanup release (startup script and sockets.pl)
% 1.2.0 Redid startup of socket communication. Multiple sicstus-grisu
%       pairs can now be started. Redid show_all_supertypes. 
% 1.1.0 now has functional version of unfilling, rewritten from scratch 
%       Added code for saving feature structure results (save_results.pl)
%       and for diffing two feature structures. Some utilities for macros,
%       e.g. displaying macro call hiearchies added to trale_extras.pl
%       And a couple of bugfixes in ghooks. (Detmar)
% 1.0.5 bugfix and cleanup release (Detmar's changes to unfill.pl,
%                                   ghooks.pl, and sockets.pl)
% 1.0.4 feature release (Detmar's additions to pth.pl, unfill.pl, ghooks.pl)
% 1.0.3 bugfix release (Gerald's change in trale.pl)


%% Define name for optionally present file with user specifications

user_startup_file('~/.trale_startup.pl').

% ----------------------------------------------------------------------------
% Load sicstus support code
:- ensure_loaded(sics).

% ----------------------------------------------------------------------------
% Handle user startup file

%% Load user startup file, if exists and not prohibited
load_user_startup :-
   user_startup_file(F0),
   absolute_file_name(F0,F),
   ( file_exists(F), environ('READ_USER_STARTUP',true) 
   ->  format('~NLoading user startup file ~w~n',[F0]),
       load_files(F,[if(changed)])
   ;   true ).

:- load_user_startup.

% ----------------------------------------------------------------------------
% Define trale_home file search path, if not yet defined, on the basis of 
% the TRALE_HOME environment variable, which has to be set in the shell 
% before this code is loaded. (Note that we here don't make use of 
% trale_search_path_add/2 since it's not yet defined at this point, but
% only in trale.pl, which we want to keep loadable by itself).

:- ( environ('TRALE_HOME',Path) 
   -> (  predicate_property(user:file_search_path(_,_), _),
         user:file_search_path(trale_home,Path)
      -> true
      ;  assertz(user:file_search_path(trale_home,Path))
      )
   ;  format(user_error,'**Error: Set variable TRALE_HOME to directory housing the trale code.~n',[]),
      halt ).

% ----------------------------------------------------------------------------
% Load the various parts of the TRALE system
% ----------------------------------------------------------------------------

% core system:
:- ensure_loaded(trale_home('trale.pl')).          

% additional libraries:
:- ensure_loaded(trale_home(lib)).          

% debugger code:
:- ensure_loaded(trale_home(interp)).
:- ensure_loaded(trale_home(trinterp)).

% Load the OSU extensions
:- nl,write('
OSU TRALE Modules 1.0
Copyright (C) 2002, Detmar Meurers
All rights reserved'),nl,nl.

% patches waiting for integration:
:- ensure_loaded(trale_home(trale_patches)).          

% code for mapping from feature structures to ALE descriptions
:- ensure_loaded(trale_home(fs2desc)).      

% predicates allowing types like ne_list, e_list and parser related 
% features like dtrs and phon to be user-defined
:- ensure_loaded(trale_home(grammar_interface)).    

% feature ordering support (currently only effective with grisu interface):
:- ensure_loaded(trale_home(feature_ordering)).    

% utilities for working with macros hiearchies
:- ensure_loaded(trale_home(macro_utils)). 

% facilty for generation of access macros
:- ensure_loaded(trale_home(extend_access)).    

% test suite support:
:- ensure_loaded(trale_home(test_suite_handling)). 

% some other extras (like saving states etc.)
:- ensure_loaded(trale_home(trale_extras)).        

% lexical rule compiler
:- ensure_loaded(trale_home('lr_compiler/main')).        

% graphviz hierarchy display
:- ensure_loaded(trale_home('graphviz')).

% chart display support code
:- ensure_loaded(trale_home('chart_display/chart_display')).

% support for saving results that are printed, e.g.
% for reprinting them (e.g. with another pretty printer),
% saving them to a file, or doing a diff on results
% Note: This needs to be loaded before any other
% pretty printing hooks in order to have any effect.
:- ensure_loaded(trale_home(save_results)).    

% load code for the graphical interface, if needed
:- (   environ('INTERFACE',text) 
   ->  true
   ;   % load pretty printing hooks for grisu interface:
       ensure_loaded(trale_home(ghooks)),
       % diff of two feature structures
       ensure_loaded(trale_home(diff)),
       % debug unifies two feature structures
       ensure_loaded(trale_home(debug_unify))   
   ).

% tsdb support: not (yet) generally loaded, call load_tsdb/0 to load
load_tsdb :- ensure_loaded(trale_home('tsdb/itsdb')),
             ensure_loaded(trale_home('tsdb/trale-itsdb')).

% call the startup code
:- trale_startup.

%%% ==================================================================
%% Local Variables:
%% mode: prolog
%% End:
