%%% $Id: trale_patches.pl,v 1.31 2003/08/09 14:44:00 dm Exp $
%
% Patches to predicates defined in trale.pl or ale.pl
%
% These should be worked into trale.pl or ale.pl at one point.
%
% -----------------------------------------------------------------
% from ale.pl

:- abolish([compile_gram/1]).

compile_gram(File):-
  clear_feature_output,         % initialize feature_ordering.pl
  abolish_preds,
  reconsult(File),
  compile_gram,
  process_feature_output.       % compile info in feature_ordering.pl


:- abolish([compile_grammar/1]).

compile_grammar(File):-
  clear_feature_output,         % initialize feature_ordering.pl
  abolish((empty)/1),abolish((rule)/2),
  abolish((lex_rule)/2),
% 5/1/96 - Octav -- added abolish/2 calls for generation predicates
  abolish(('--->')/2),
  abolish((semantics)/1),
  reconsult(File),
  compile_grammar,
  process_feature_output.       % compile info in feature_ordering.pl


% -------------------------------------------
% from trale.pl (which patches that predicate from ale.pl)

:- abolish([abolish_preds/0]).

abolish_preds :-  
  abolish((empty)/1), abolish((rule)/2), abolish((lex_rule)/2), 
  abolish(('--->')/2), abolish((sub)/2), 
  abolish((if)/2), abolish((':=')/2), abolish((macro)/2),
  abolish((ext)/1), abolish((cons)/2), abolish(('*>')/2),
  abolish((intro)/2),
% 5/1/96 - Octav -- added abolish/2 calls for generation predicates
  abolish((semantics)/1),
  abolish(('+++>')/2), abolish((fun)/1),
  abolish((trale_cons)/2),  abolish((signature)/1),
  %
  % added: some interface predicates defined in grammar_interface.pl
  % 
  abolish(dtrs_feat/1),
  abolish(phon_feat/1),
  abolish(list_type/1),
  abolish(ne_list_type/1),
  abolish(hd_feat/1),
  abolish(tl_feat/1).

