% This file only maps the tree_extension syntax to the ordinary
% syntax (i.e. it does not introduce the dtrs and phon attribute).

:- multifile term_expansion/2.
:- discontiguous term_expansion/2.

% ------------------------------------------------------
% new operators

:-op(1150,xfx,~~>).  % lexical entries
:-op(1150,fx,trace). % empty element
:-op(1175,xfx,##).   % used for rule and lex_rule

% ------------------------------------------------------
% translating new lexical entry syntax

term_expansion((Phon ~~> Desc),
	       (Phon ---> Desc)).

% ------------------------------------------------------
% translating empty elements

term_expansion((trace Desc),
	       (empty Desc)).

% ------------------------------------------------------
% translating new lexical rule syntax

term_expansion(##(Name,morphs(Rule,Morphs)),
	       lex_rule(Name,morphs(Rule,Morphs))).

% ------------------------------------------------------
% translating new phrase structure rule syntax

term_expansion((RuleName ## Moth ===> Dtrs),
	       (RuleName rule Moth ===> Dtrs)).
