%%% ==================================================================
%%%
%%% Some utilities for use in the TRALE system
%%%
%%% $Id: utilities.pl,v 1.41 2003/05/02 15:34:15 dm Exp $
%%%
%%% Time-stamp: <dm on 02.May.2003 11:34:02 EDT>
%%%
%%% ==================================================================


% ---------------------
% writeln/1

writeln([]) :- nl.
writeln([H|T]) :-
	write(H),
	writeln(T).

% ---------------------
% proceed_or_abort/1

proceed_or_abort :-
	write(user_output,' *** Continue anyway? (y/n): '),
	current_input(Stream),
	set_input(user_input),
	get_line(Answer),nl,
	set_input(Stream),
	( Answer = [121] ->
	    true
	;   seen,
	    told,
	    abort).

% ---------------------
% capitalize_atom/2
% capitalize_string/2
% capitalize_char/2

capitalize_atom(Feat,CapFeat) :-
   name(Feat,String),
   capitalize_string(String,CapString),
   name(CapFeat,CapString).

capitalize_string([],[]).
capitalize_string([H|T],[CapH|CapT]) :-
   capitalize_char(H,CapH),
   capitalize_string(T,CapT).

capitalize_char(X,XCap):-
   ( (97 =< X, X =< 122)	% char codes: a = 97, z = 122, A = 65
   -> XCap is X - 32		% => from a to A is -32
   ; XCap = X
   ).
